#!/bin/bash

B="/tmp/comprueba-te2"
SEP="------------------------------------------------------------------"

SCENARIO='rdor-te2-caso-estudio.xml'

# Creamos script comprueba-te2
cat > $B << "FIN-B"
#!/bin/bash

echo "Comprobando hosts..."
HOSTS="h1 h2 h3 h4 h5 h6 wifi1 s1 s2"
echo $HOSTS

for r in $HOSTS; do
  echo -n "Host $r: "
  counter=3
  while true
  do
    #ss=$( nmap -p 22 $r | grep ssh) > /dev/null
    ss=$( sudo lxc-info -n $r -s -H ) 
    #echo "** $r -> $ss"
    if [ "$ss" != "RUNNING" ]; then
          if [ $counter -eq 0 ]; then
            echo " ERROR"
            FALLOS="$FALLOS $r"
            break
          else
            echo -n "."
            counter=$(( $counter -1 ))
            sleep 3
          fi
    else
          echo "arrancado"
          break
    fi
  done
done

echo ""
echo "Comprobando routers..."
ROUTERS="r1 r2 r3 r4 r5"
echo $ROUTERS

for r in $ROUTERS; do
  echo -n "Router $r: "
  counter=3
  while true
  do
    #ss=$( nmap -p 22 $r | grep ssh) > /dev/null
    ss=$( sudo lxc-info -n $r -s -H ) 
    if [ "$ss" != "RUNNING" ]; then
          if [ $counter -eq 0 ]; then
            echo " ERROR"
            FALLOS="$FALLOS $r"
            break
          else
            echo -n "."
            counter=$(( $counter -1 ))
            sleep 3
          fi
    else
          echo "arrancado"
          break
    fi
  done
done


echo $SEP
if [ "$FALLOS" = "" ]; then
    echo "Escenario arrancado correctamente."
else
    echo "ERROR: algunos sistemas no arrancaron correctamente ($FALLOS )"
    echo "       Rearranque el escenario de nuevo"
fi
echo $SEP

FIN-B

function limpia () {

# Hacemos limpieza primero...
PIDS=$( ps uaxww | grep "comprueba-te2" | grep -v grep | awk '{ print $2 }' )
if [ "$PIDS" ]; then
    echo "Matando procesos comprueba-te2:" $PIDS
    sudo kill -9 $PIDS
else
    echo "No hay procesos comprueba-te2"
fi

PIDS=$( ps uaxww | grep "nmap" | grep -v grep | awk '{ print $2 }' )
if [ "$PIDS" ]; then
    echo "Matando procesos nmap:" $PIDS
    sudo kill -9 $PIDS
else
    echo "No hay procesos nmap"
fi

#sudo vnx -D
sudo vnx -f $SCENARIO -v -P -D

}

limpia
sudo vnx -f $SCENARIO -t
echo ''; echo "$SEP"; echo ''
sleep 2
sh $B
echo "$SEP"

#( limpia; sudo vnx -f $SCENARIO -v -t; echo ''; echo "$SEP"; echo ''; sleep 2; sh $B; echo "$SEP"; ) | yad --text-info --tail --title 'Arrancando escenario RDOR te2...' --height 400 --width 800 --fontname="Monospace 7" --wrap &
